<template>
  <div>
    <InfoBox title="Nachrichten">
      <template slot="header-action">
        <TextFilter
          :filter-value="filterValue"
          @filter-change="handleNewsFilterChange"
        />
      </template>

      <template v-if="filteredNews.length">
        <a
          v-for="article in filteredNews"
          :key="article.id"
          class="article flex gap-3 mt-4"
          :href="article.linkurl"
          target="_blank"
        >
          <img class="article__img flex-none w-24 h-12 mt-1" :src="article.imageUrl" alt="">
          <div class="article__text-container flex-1">
            <p class="article__text text-sm text-gray-700 dark:text-brand-white">
              {{ article.title }}
            </p>
            <p class="article__timestamp text-xs text-gray-400 mt-1">{{ formatTimestamp(article.timestamp) }}</p>
          </div>
        </a>
      </template>
      <p v-else>
        Deine Suche nach "{{ filterValue }}" ergab keine passenden Treffer.
      </p>
    </InfoBox>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapState } from 'vuex';
import { formatDistance } from 'date-fns';
import { Article } from '../types';

export default Vue.extend({
  data () {
    return {
      filterValue: ''
    };
  },

  computed: {
    ...mapState({
      news: (state: any) => state.news as Article[]
    }),

    filteredNews (): Article[] {
      if (!this.filterValue) {
        return this.news.slice(0, 4);
      }

      return this.news.filter(item => item.title.toLowerCase().includes(this.filterValue.toLowerCase())).slice(0, 4);
    }
  },

  methods: {
    formatTimestamp (timestamp:string) {
      const date = new Date(timestamp);

      return formatDistance(date, new Date(), {
        addSuffix: true
      });
    },

    handleNewsFilterChange (value: string) {
      this.filterValue = value;
    }
  }
});
</script>

<style lang="scss" scoped>
.article {
  object-fit: cover;
}
</style>
